Index: trunk/MagicSoft/Mars/mhist/MFillH.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MFillH.cc	(revision 1027)
+++ trunk/MagicSoft/Mars/mhist/MFillH.cc	(revision 1030)
@@ -25,5 +25,5 @@
 //////////////////////////////////////////////////////////////////////////////
 //                                                                          //
-//  MFill                                                                   //
+//  MFillH                                                                  //
 //                                                                          //
 //  This is a common interface (task) to fill mars histograms. Every mars   //
@@ -35,4 +35,12 @@
 //  objects in the parameter list or by specifiing a pointer to the object. //
 //  (s. Constructor)                                                        //
+//                                                                          //
+//  WARNING:                                                                //
+//   Because MFillH is a generalized task to fill histograms it doesn't     //
+//   know about which branches from a file are necessary to fill the        //
+//   histograms. If you are reading data from a file which is directly      //
+//   filled into a histogram via MFillH, please call either                 //
+//   MReadTree::DisableAutoScheme() or enable the necessary branches by     //
+//   yourself, using MReadTree::EnableBranch()                              //
 //                                                                          //
 //  Input Containers:                                                       //
Index: trunk/MagicSoft/Mars/mhist/MHFadcCam.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHFadcCam.cc	(revision 1027)
+++ trunk/MagicSoft/Mars/mhist/MHFadcCam.cc	(revision 1030)
@@ -44,12 +44,12 @@
 //  creates an a list of histograms for all pixels and both gain channels
 //
-MHFadcCam::MHFadcCam (const char *name, const char *title)
+#include <iostream.h>
+MHFadcCam::MHFadcCam(const char *name, const char *title)
 {
     //
     //   set the name and title of this object
     //
-    
-    fName  = name  ? name  : "MHFadcCam" ;
-    fTitle = title ? title : "Container for ADC spectra histograms" ;
+    fName  = name  ? name  : "MHFadcCam";
+    fTitle = title ? title : "Container for ADC spectra histograms";
 
     //
@@ -65,7 +65,24 @@
 
 // --------------------------------------------------------------------------
-MHFadcCam::~MHFadcCam ()
+MHFadcCam::~MHFadcCam()
 {
     delete fArray;
+}
+
+// --------------------------------------------------------------------------
+//
+// Our own clone function is necessary since root 3.01/06 or Mars 0.4
+// I don't know the reason
+//
+TObject *MHFadcCam::Clone(const char *) const
+{
+    MHFadcCam *cam = new MHFadcCam;
+
+    for (int i=0; i<577; i++)
+    {
+        delete (*cam->fArray)[i];
+        (*cam->fArray)[i] = (MHFadcPix*)(*fArray)[i]->Clone();
+    }
+    return cam;
 }
 
Index: trunk/MagicSoft/Mars/mhist/MHFadcCam.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHFadcCam.h	(revision 1027)
+++ trunk/MagicSoft/Mars/mhist/MHFadcCam.h	(revision 1030)
@@ -26,5 +26,5 @@
 
 public:
-     MHFadcCam(const char *name=NULL, const char *title=NULL);
+    MHFadcCam(const char *name=NULL, const char *title=NULL);
     ~MHFadcCam();
 
@@ -46,5 +46,7 @@
     void DrawPix(UInt_t i)     { (*this)[i]->Draw(); }
 
-    Int_t GetEntries()         { return fArray->GetEntries(); }
+    Int_t GetEntries() const   { return fArray->GetEntries(); }
+
+    TObject *Clone(const char *opt="") const;
 
     ClassDef(MHFadcCam, 1) // A list of histograms storing the Fadc spektrum of one pixel
Index: trunk/MagicSoft/Mars/mhist/MHFadcPix.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHFadcPix.cc	(revision 1027)
+++ trunk/MagicSoft/Mars/mhist/MHFadcPix.cc	(revision 1030)
@@ -54,6 +54,6 @@
 
     fHistHi->SetDirectory(NULL);
-    fHistHi->SetXTitle("Time/Slices");
-    fHistHi->SetYTitle("Signal");
+    fHistHi->SetXTitle("Signal/FADC Units");
+    fHistHi->SetYTitle("Count");
 
     delete [] name;
@@ -66,6 +66,6 @@
 
     fHistLo->SetDirectory(NULL);
-    fHistLo->SetXTitle("Time/Slices");
-    fHistLo->SetYTitle("Signal");
+    fHistLo->SetXTitle("Signal/FADC Units");
+    fHistLo->SetYTitle("Count");
 
     delete [] name;