Index: trunk/MagicSoft/Simulation/Detector/Camera/creadparam.cxx
===================================================================
--- trunk/MagicSoft/Simulation/Detector/Camera/creadparam.cxx	(revision 899)
+++ trunk/MagicSoft/Simulation/Detector/Camera/creadparam.cxx	(revision 1068)
@@ -19,7 +19,7 @@
 //=
 //= $RCSfile: creadparam.cxx,v $
-//= $Revision: 1.11 $
-//= $Author: magicsol $ 
-//= $Date: 2001-07-25 11:38:00 $
+//= $Revision: 1.12 $
+//= $Author: blanch $ 
+//= $Date: 2001-11-13 17:05:14 $
 //=
 //=//////////////////////////////////////////////////////////////////////
@@ -70,4 +70,6 @@
 static char Input_filename[PATH_MAX_LENGTH];  //@< input filename
 static char Starfield_filename[PATH_MAX_LENGTH]; //@< starfield input filename
+static int Starfield_center[6];               //@< center of the starfield FOV
+                                              //@< RA(H,M,S) & DEC (D,M,S)
 static char Data_filename[PATH_MAX_LENGTH];   //@< data filename
 static char ROOT_filename[PATH_MAX_LENGTH];   //@< data filename
@@ -121,4 +123,12 @@
 static float FADC_response_ampl = MFADC_RESPONSE_AMPLITUDE;
 static float FADC_response_fwhm = MFADC_RESPONSE_FWHM;
+static float Telescope_axis_th = 0.;  //<@ Theta of the axis telescope
+static float Telescope_axis_ph = 90.; //<@ Phi of the axis telescope
+static float Source_offset_th=0.;     //<@  Displacement in Theta of the 
+                                      //<@ source from the center
+static float Source_offset_ph=0.;     //<@  Displacement in Phi of the 
+                                      //<@ source from the center
+static int Corsika_vers=5200;         //<@ Version of Corsika  
+
 //!@}
 
@@ -213,4 +223,11 @@
       break;
 
+    case starfield_center:         //@< name of the output file
+          
+      // get the name of the output_file from the line
+	sscanf(line, "%s %i %i %i %i %i %i", token, &Starfield_center[0], &Starfield_center[1], &Starfield_center[2], &Starfield_center[3], &Starfield_center[4], &Starfield_center[5]);
+
+      break;
+      
     case data_file:           //@< name of the data file
           
@@ -469,4 +486,25 @@
       break;
 
+     case telescope_axis:
+
+      //  Get axis of the telescope
+	 sscanf(line, "%s %f %f", token, &Telescope_axis_th, &Telescope_axis_ph);
+
+      break;
+
+    case source_offset:
+
+      //  Get offset of source
+	sscanf(line, "%s %f %f", token, &Source_offset_th, &Source_offset_ph);
+
+      break;
+
+    case corsika_vers:
+
+      //  Get Corsika version
+	sscanf(line, "%s %i", token, &Corsika_vers);
+
+      break;
+
     case Trigger_Loop_Output_Only_Specialists:
 
@@ -536,4 +574,27 @@
 //!@}
 
+
+//!-----------------------------------------------------------
+// @name get_starfield_center
+//                                                
+// @desc get center of the starfield FOV
+//
+// @return   Central co-ordinates in RA and DEC for the centre of FOV
+//
+// @date Tue Feb 15 16:02:18 CET 2000
+//------------------------------------------------------------
+// @function 
+
+//!@{
+void get_starfield_center(int *rh,int *rm,int *rs,int *dd,int *dm,int *ds)
+{
+    *rh=Starfield_center[0];
+    *rm=Starfield_center[1];
+    *rs=Starfield_center[2];
+    *dd=Starfield_center[3];
+    *dm=Starfield_center[4];
+    *ds=Starfield_center[5];
+}
+//!@}
 
 //!-----------------------------------------------------------
@@ -1176,4 +1237,49 @@
 //!@}
 
+//!-----------------------------------------------------------
+// @name get_teles_axis
+//                                                
+// @desc give axis of the telescope 
+//
+//------------------------------------------------------------
+// @function 
+
+//!@{
+void get_teles_axis(float *th, float *p){
+    *th=Telescope_axis_th;
+    *p=Telescope_axis_ph;
+}
+//!@}
+
+//!-----------------------------------------------------------
+// @name get_source_off
+//                                                
+// @desc give the offset of the source to the center of the camera 
+//
+//------------------------------------------------------------
+// @function 
+
+//!@{
+void get_source_off(float *th, float *p){
+    *th=Source_offset_th;
+    *p=Source_offset_ph;
+}
+//!@}
+
+//!-----------------------------------------------------------
+// @name get_corsika_vers
+//                                                
+// @desc give the vrsion of corsika 
+//
+//------------------------------------------------------------
+// @function 
+
+//!@{
+int get_corsika_ver(void){
+    return(Corsika_vers);
+}
+//!@}
+
+
 //=------------------------------------------------------------
 //!@subsection Log of this file.
@@ -1182,4 +1288,7 @@
 //
 // $Log: not supported by cvs2svn $
+// Revision 1.11  2001/07/25 11:38:00  magicsol
+// Minnor changes
+//
 // Revision 1.10  2001/07/19 09:28:30  blanch
 // A new command, which allows to set individual trigger threshod for each pixel,