Index: trunk/MagicSoft/Mars/mhist/HistLinkDef.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/HistLinkDef.h	(revision 1209)
+++ trunk/MagicSoft/Mars/mhist/HistLinkDef.h	(revision 1210)
@@ -8,5 +8,4 @@
 
 #pragma link C++ class MH+;
-#pragma link C++ class MBinning+;
 #pragma link C++ class MHFadcCam+;
 #pragma link C++ class MHFadcPix+;
@@ -14,6 +13,16 @@
 #pragma link C++ class MHHillasSrc+;
 #pragma link C++ class MHStarMap+;
+#pragma link C++ class MHEnergyTime+;
+#pragma link C++ class MHEnergyTheta+;
 #pragma link C++ class MHMcEnergy+;
 #pragma link C++ class MHMcCollectionArea+;
+#pragma link C++ class MHAlphaEnergyTime;
+#pragma link C++ class MHAlphaEnergyTheta;
+#pragma link C++ class MHEffOnTimeTime+;
+#pragma link C++ class MHEffOnTimeTheta+;
+#pragma link C++ class MHDiffTimeTime+;
+#pragma link C++ class MHDiffTimeTheta+;
+
+#pragma link C++ class MBinning+;
 
 #pragma link C++ class MHMcRate+;
Index: trunk/MagicSoft/Mars/mhist/MFillH.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MFillH.cc	(revision 1209)
+++ trunk/MagicSoft/Mars/mhist/MFillH.cc	(revision 1210)
@@ -87,6 +87,6 @@
     fTitle = title ? title : "Task to fill Mars histograms";
 
-    fH            = NULL;
-    fParContainer = NULL;
+    fH                = NULL;
+    fParContainer     = NULL;
 }
 
Index: trunk/MagicSoft/Mars/mhist/MHHillas.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHHillas.cc	(revision 1209)
+++ trunk/MagicSoft/Mars/mhist/MHHillas.cc	(revision 1210)
@@ -40,4 +40,5 @@
 
 #include "MHillas.h"
+#include "MParList.h"
 
 ClassImp(MHHillas);
@@ -47,11 +48,11 @@
 // Setup four histograms for Width, Length
 //
-MHHillas::MHHillas (const char *name, const char *title)
+MHHillas::MHHillas(const char *name, const char *title)
 {
     //
     //   set the name and title of this object
     //
-    fName  = name  ? name  : "MHHillas" ;
-    fTitle = title ? title : "Container for Hillas histograms" ;
+    fName  = name  ? name  : "MHHillas";
+    fTitle = title ? title : "Container for Hillas histograms";
 
     //
@@ -81,4 +82,24 @@
     delete fWidth;
     delete fLength;
+}
+
+// --------------------------------------------------------------------------
+//
+// Setup the Binning for the histograms automatically if the correct
+// instances of MBinning (with the names 'BinningWidth' and 'BinningLength')
+// are found in the parameter list
+//
+Bool_t MHHillas::SetupFill(const MParList *plist)
+{
+    const MBinning* binsw = (MBinning*)plist->FindObject("BinningWidth");
+    const MBinning* binsl = (MBinning*)plist->FindObject("BinningLength");
+
+    if (binsw)
+        SetBinning(fWidth, binsw);
+
+    if (binsl)
+        SetBinning(fLength, binsl);
+
+    return kTRUE;
 }
 
Index: trunk/MagicSoft/Mars/mhist/MHHillas.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHHillas.h	(revision 1209)
+++ trunk/MagicSoft/Mars/mhist/MHHillas.h	(revision 1210)
@@ -19,4 +19,5 @@
     ~MHHillas();
 
+    Bool_t SetupFill(const MParList *pList);
     Bool_t Fill(const MParContainer *par);
 
Index: trunk/MagicSoft/Mars/mhist/MHHillasSrc.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHHillasSrc.cc	(revision 1209)
+++ trunk/MagicSoft/Mars/mhist/MHHillasSrc.cc	(revision 1210)
@@ -38,4 +38,6 @@
 #include <TCanvas.h>
 
+#include "MParList.h"
+
 #include "MHillas.h"
 #include "MHillasSrc.h"
@@ -52,6 +54,6 @@
     //   set the name and title of this object
     //
-    fName  = name  ? name  : "MHHillasSrc" ;
-    fTitle = title ? title : "Container for Hillas histograms" ;
+    fName  = name  ? name  : "MHHillasSrc";
+    fTitle = title ? title : "Container for Hillas histograms";
 
     //
@@ -81,4 +83,24 @@
     delete fAlpha;
     delete fDist;
+}
+
+// --------------------------------------------------------------------------
+//
+// Setup the Binning for the histograms automatically if the correct
+// instances of MBinning (with the names 'BinningAlpha' and 'BinningDist')
+// are found in the parameter list
+//
+Bool_t MHHillasSrc::SetupFill(const MParList *plist)
+{
+    const MBinning* binsa = (MBinning*)plist->FindObject("BinningAlpha");
+    const MBinning* binsd = (MBinning*)plist->FindObject("BinningDist");
+
+    if (binsa)
+        SetBinning(fAlpha, binsa);
+
+    if (binsd)
+        SetBinning(fDist, binsd);
+
+    return kTRUE;
 }
 
Index: trunk/MagicSoft/Mars/mhist/MHHillasSrc.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHHillasSrc.h	(revision 1209)
+++ trunk/MagicSoft/Mars/mhist/MHHillasSrc.h	(revision 1210)
@@ -19,4 +19,5 @@
     ~MHHillasSrc();
 
+    Bool_t SetupFill(const MParList *pList);
     Bool_t Fill(const MParContainer *par);
 